(* 忽略下面这一行 *)
Module Definations.
(* 忽略上面这一行 *)





(* 我们必须要熟知的一些定义 *)
Inductive nat : Type :=
  | O
  | S (n : nat).

Fixpoint plus (a b : nat) :=
  match a with
  | O => b
  | S a' => S (plus a' b)
  end.

Fixpoint mult (n m : nat) : nat :=
  match n with
  | O => O
  | S n' => plus m (mult n' m)
  end.










(* 忽略下面这一行 *)
End Definations.
(* 忽略上面这一行 *)











(* 我们的骚操作 *)
Inductive mytype :=
  | Root1
  | Root2
  | Transform1 (my : mytype)
  | Transform2 (my1 : mytype) (my2 : mytype).














(* 暖场的例子 *)
Goal forall m n : nat,
  m = 1 + n -> m = 1 -> 0 + n = 0.
Proof.
  intros.
  rewrite H in H0.
  simpl.
  simpl in H0.
  destruct n.
  - reflexivity.
  - discriminate.
Qed.









(* 为什么要用 induction / 之前策略的局限在哪里 *)
Goal forall n:nat, n + 0 = n.
Proof.
  intros.
  destruct n as [|n'].
  - reflexivity.
  - simpl.
    destruct n' as [|n''].
    + reflexivity.
    + simpl.
Abort.











(* 如何使用 induction *)
Goal forall n:nat, n + 0 = n.
Proof.
  intros.
  induction n as [|n'].
  - reflexivity.
  - simpl. rewrite IHn'. reflexivity.
Qed.












(* 如何使用 induction / 为下文预备 *)
Theorem plus_comm : forall n m : nat,
  n + m = m + n.
Proof.
  induction m.
  - rewrite plus_n_O.
    reflexivity.
  - rewrite <- plus_n_Sm.
    rewrite IHm.
    reflexivity.
Qed.
Theorem plus_assoc : forall n m p : nat,
  n + (m + p) = (n + m) + p.
Proof.
  intros.
  induction n.
  - reflexivity.
  - simpl.
    rewrite IHn.
    reflexivity.
Qed.
Theorem plus_swap : forall n m p : nat,
  n + (m + p) = m + (n + p).
Proof.
  intros.
  rewrite -> plus_assoc.
  rewrite -> (plus_comm n m).
  rewrite <- plus_assoc.
  reflexivity.
Qed.







(* 几个小问题热热身，接下来的难题才看得懂 *)
Goal forall (n : mytype), n = n.
Proof.
  destruct n.
  - reflexivity.
  - reflexivity.
  - reflexivity.
  - reflexivity.
Qed.
Goal forall (n : mytype), n = n.
Proof.
  induction n.
  - reflexivity.
  - reflexivity.
  - reflexivity.
  - reflexivity.
Qed.








(* 高斯求和 *)
Fixpoint sum_to (n : nat) := 
  match n with
  | O => O
  | S n' => n + (sum_to n')
  end.

(* 高斯求和公式——解法1 *)
Lemma sum_helper : forall n : nat,
  2 * sum_to (S n) = 2 * (S n) + 2 * (sum_to n).
Proof.
  intros.
  simpl.
  rewrite <- plus_n_O.
  rewrite <- plus_n_O.
  rewrite <- plus_n_O.
  rewrite <- plus_assoc.
  rewrite (plus_comm (sum_to n)).
  rewrite <- plus_assoc.
  simpl.
  rewrite plus_assoc.
  reflexivity.
Qed.
Theorem mult_a_Sb' : forall a b : nat,
  a * S b = a * b + a.
Proof.
  intros.
  induction a.
  - reflexivity.
  - simpl.
    rewrite IHa.
    rewrite plus_assoc.
    assert (H: forall x y:nat, x + (S y) = S (x+y)). {
      intros.
      rewrite plus_comm.
      simpl.
      rewrite plus_comm.
      reflexivity.
    }
    rewrite H.
    reflexivity.
Qed.
Theorem sum_to_eqn : forall n : nat,
  2 * (sum_to n) = n * (n + 1).
Proof.
  induction n.
  - reflexivity.
  - (* S n *)
    rewrite sum_helper.
    rewrite IHn.
    simpl.
    rewrite <- plus_n_O.
    rewrite (plus_comm n 1).
    rewrite (plus_comm n).
    simpl.
    rewrite mult_a_Sb'.
    rewrite mult_a_Sb'.
    rewrite mult_a_Sb'.
    rewrite plus_assoc.
    rewrite (plus_comm (n * n)).
    rewrite plus_assoc.
    rewrite plus_assoc.
    reflexivity.
Qed.










Theorem mult_a_Sb : forall a b : nat,
  a * S b = a * b + a.
Proof.
  intros.
  induction a.
  - reflexivity.
  - simpl.
    rewrite IHa.
    rewrite plus_assoc.
    rewrite <- (plus_comm (S a)).
    simpl.
    rewrite (plus_comm a).
    reflexivity.
Qed.
Theorem sum_to_eqn2 : forall n : nat,
  sum_to n + sum_to n = n * S n.
Proof.
  induction n.
  - reflexivity.
  - simpl.
    rewrite (mult_a_Sb n (S n)).
    rewrite plus_assoc.
    rewrite plus_comm.
    simpl.
    rewrite plus_swap.
    rewrite <- plus_assoc.
    rewrite IHn.
    rewrite plus_comm.
    reflexivity.
Qed.













(* 最终，intros需要注意的地方 *)
Fixpoint double (n : nat) : nat :=
  match n with
  | O => O
  | S n' => S (S (double n'))
  end.

Theorem double_injective: forall n m,
  double n = double m -> n = m.
Proof.
  intros n. induction n as [ | n' IHn'].
  - (* n = 0 *) 
    intros m eq. simpl in eq.
    destruct m as [ | m'] eqn:E.
    + (* E : m = 0 *)
      reflexivity.
    + (* E : m = S m' *)
      simpl in eq. discriminate eq. (* 下面解释这句话 *)
  - (* n = S n' *)
    simpl. intros m eq.
    destruct m as [ | m'] eqn:E.
    + (* E : m = 0 *) simpl in eq. discriminate eq.
    + (* E : m = S m' *) 
      apply f_equal.
      apply IHn'.
      simpl in eq.
      injection eq as H. (* 下面解释这句话 *)
      apply H.
Qed.

Theorem double_injective_FAILED : forall n m,
     double n = double m -> n = m.
Proof.
  intros n m.
  induction n as [| n' IHn'].
  - (* n = O *) simpl. intros eq. destruct m as [| m'] eqn:E.
    + (* m = O *) reflexivity.
    + (* m = S m' *) discriminate eq. (* [simpl in eq] 不必要 *)
  - (* n = S n' *) intros eq. destruct m as [| m'] eqn:E.
    + (* m = O *) discriminate eq.
    + (* m = S m' *) apply f_equal.
Abort.



